/*InputMakers
Projecte del braç robòtic: controlarem el moviment dels quatre 
servos SG90 que mouen el braç mitjançant quatre potenciòmetres.
 */

#include <Servo.h> //Incloem la llibreria Servo.h que ens permetrà gestionar el moviment dels servos.
 
 /*Creem variables amb el nom de cada servo
 i els assignem als pins PWM on estaran connectats.*/
const int servo1 = 3;      
const int servo2 = 5;       
const int servo3 = 6;       
const int servo4 = 9; 
      
/* Calibrem els servos amb polsMin i polsMax.*/
int polsMin = 900;  // Pols en microsegons corresponent a l'angle de 0º.
int polsMax = 2100; // Pols en microsegons corresponent a l'angle de 180º.

Servo myservo1;  // Creem els Servos.
Servo myservo2;
Servo myservo3;
Servo myservo4;

void setup() {
  
 /* Assignem els pins als servos, ajustem els valors de pols mínim
  i màxim.*/
  myservo1.attach(servo1, polsMin, polsMax);  
  myservo2.attach(servo2, polsMin, polsMax);  
  myservo3.attach(servo3, polsMin, polsMax); 
  myservo4.attach(servo4, polsMin, polsMax); 

}

void loop(){

    /* Llegim el valor del potenciòmetre amb analogRead en cada pin
     d'entrada analògica A0, A1, A2 i A3.
     A continuació escalem amb map els valors del potenciòmetre
     (Que van de 0 a 1023 per a l'entrada analògica)
     als valors de moviment del servo (que van de 0 a 180 graus)
     Per últim assignem el valor al servo corresponent.*/
         
    int servoVal1 = map(analogRead(A0), 0, 1023, 0, 180);       
    int servoVal2 = map(analogRead(A1), 0, 1023, 0, 180);               
    int servoVal3 = map(analogRead(A2), 0, 1023, 0, 180);         
    int servoVal4 = map(analogRead(A3), 0, 1023,0, 180);    
    myservo1.write(servoVal1);
    myservo2.write(servoVal2);
    myservo3.write(servoVal3); 
    myservo4.write(servoVal4);                           

    delay(15);  // detenim el programa 15 ms per a que el servo es posicioni.                                  

}
